////////////////////////////////////////////////////////
// Panels, Definitionen und Actions fuer SKAPHANDER-Demo
///////////////////////////////////////////////////////
VIDEO		X320x400;
#VIDEO		S640x480;
#IBANK		<op.ibk>;
#DRUMBANK	<opdrum.ibk>;
MIDI_PITCH	2;
////////////////////////////////////////////////
STRING pause_on,"Pause";
STRING have_jet,"Jetbooster installed\nPress HOME/JOY4 for ignition";
STRING full_ammo,"Full Data Refresh\nVery Happy Debugging";
////////////////////////////////////////////////
DEFINE armor,SKILL1;
DEFINE counter,SKILL1;
DEFINE dead,FLAG7;
////////////////////////////////////////////////
SOUND zschbumm,<skaplod5.wav>;
SOUND tschok,<ttrff2.wav>;
SOUND booster, <jet.wav>;
SOUND energy_low,<e_alarm.wav>;
////////////////////////////////////////////////
// Skills, die bei jedem Start erhalten bleiben
SKILL	MOTION_BLUR	{ TYPE GLOBAL; VAL 0.5; MIN 0; MAX 1.5; }
SKILL	old_music 	{ TYPE GLOBAL; VAL 0.5; MIN 0; MAX 1; }
SKILL	old_sound 	{ TYPE GLOBAL; VAL 0.75; MIN 0; MAX 0.75; }
SKILL	smus		 	{ TYPE GLOBAL; VAL 0; }
SKILL	screen_size	{ TYPE GLOBAL; VAL 1; }
SKILL	slot			{ TYPE GLOBAL; VAL 1; } // Zuletzt gesaveter slot (1..3)
SKILL	max_level	{ TYPE GLOBAL; VAL 0; }	// Maximal erreichter Level
SKILL	via_nexlev	{ TYPE GLOBAL; VAL 0; }	// Einsprung via next_level
SKILL difficulty	{ TYPE GLOBAL; VAL 2; 	MIN 0; MAX 2; }

// Skills, die auf den Zustand bei jedem Levelstart
// zurueckgesetzt werden

SKILL points		{ TYPE GLOBAL; VAL 0; 	MIN 0; }
SKILL health		{ TYPE GLOBAL; VAL 300; MIN 0; MAX 600; }
SKILL energy		{ TYPE GLOBAL; VAL 200; MIN 0; MAX 600; }
SKILL	gun_type		{ TYPE GLOBAL; VAL 0; }
SKILL gun1 			{ TYPE GLOBAL; VAL 0; }
SKILL gun2 			{ TYPE GLOBAL; VAL 0; }
SKILL gun3 			{ TYPE GLOBAL; VAL 0; }
SKILL gun4 			{ TYPE GLOBAL; VAL 0; }
SKILL minen			{ TYPE GLOBAL; VAL 0; }
SKILL wisen			{ TYPE GLOBAL; VAL 0; }
SKILL shield		{ TYPE GLOBAL; MIN 0; VAL 0; }
SKILL gun5 			{ VAL 1; }	// saege - NICHT global!
////////////////////////////////////////////////
SKILL SOUND_VOL	{ VAL 0.75; MIN 0; MAX 0.75; }
SKILL MUSIC_VOL	{ VAL 0.6; MIN 0; MAX 1; }
SKILL PLAYER_LIGHT	{ VAL 0.5;	}
SKILL PLAYER_WIDTH	{ VAL 2.5;	}
SKILL PLAYER_CLIMB	{ VAL 1.6;	}
SKILL MAP_SCALE		{ VAL 3; MIN 0.1; MAX 30; }
SKILL MAP_ROT			{ VAL 1; }
SKILL COLOR_BORDER	{ VAL 240; }
SKILL COLOR_WALLS		{ VAL 244; }

SKILL SHOOT_SECTOR	{ VAL 0; }
SKILL my_light			{ VAL 0.5; }
SKILL abschussquote	{ VAL 0; }
SKILL virenquote		{ VAL 0; }	// viren pro level
SKILL bugs_weg			{ VAL 0; }
SKILL bugquote			{ VAL 0; }	// bugs pro level
SKILL	praemie 			{}
SKILL save_no			{ VAL 0; }
SKILL slot_no			{ VAL 0; }
SKILL freeze			{ VAL 0; }	// move_mode 0;
SKILL service_mode	{ VAL 0; }
SKILL pause				{ VAL 0; }
SKILL old_maxlev		{ VAL 0; }
SKILL old_difficulty	{ VAL -1; 	MIN 0; MAX 2; }
SKILL old_points		{ VAL 0; 	MIN 0; }
SKILL old_health		{ VAL 300;	MIN 0; MAX 400; }
SKILL old_energy		{ VAL 200;	MIN 0; MAX 300; }
SKILL old_gun1 		{ VAL 0; }
SKILL old_gun2 		{ VAL 0; }
SKILL old_gun3 		{ VAL 0; }
SKILL old_gun4 		{ VAL 0; }
SKILL old_minen		{ VAL 0; }
SKILL old_shield		{ VAL 0; MIN 0; }
SKILL	frame_color		{ VAL 1;}
/////////////////////////////////////////////////////////
SKILL	message_delay	{ VAL 0; }		// delay in ticks
/////////////////////////////////////////////////////////
SYNONYM fire		{ TYPE ACTION; }
SYNONYM set_gun	{ TYPE ACTION; }
/////////////////////////////////////////////////////////
// Default-Werte fuer neue Agenten
ACTION set_defaults {
	SET	difficulty,-1;
	SET	slot,1;
	BRANCH	set_def1;
}

ACTION set_def1 {
	SET 	max_level,0;
	SET	points,0;
	SET	health,300;
	SET	energy,200;
	SET	gun1,0;
	SET	gun2,0;
	SET	gun3,0;
	SET	gun4,0;
	SET	minen,0;
	SET	gun5,0;
	SET	shield,25;
}

/*
ACTION skaph_lload {	// start des aktuellen levels laden
	RULE 		slot_no = 5*level_no + 100*last_player;
	LOAD		"SKAPH",slot_no;
// Bei Fehlschlag raus
	BRANCH	skaph_fadeout;
}

ACTION skaph_exit {
	CALL	skaph_gsave;			// letzten Skill-Stand sichern
	SET	EACH_TICK.14,NULL;
	SET	EACH_TICK.15,NULL;
	SET	EACH_TICK.16,skaph_fadeout;
}
*/
/*
ACTION load_level {				// naechsten levelstart laden
	CALL		skaph_gsave;		// Aktuelle globals sichern
	RULE		slot_no = 5*level_no + 5;	// naechster level
	BRANCH	skaph_load;
}
*/

/////////////////////////////////////////////////////////
FONT		msg_font,<font_amb.lbm>,8,16;
STRING	nullstring," ";
STRING	erastring,"_";
TEXT screen_msg {
	POS_X 	30;
	POS_Y 	24;
	FONT		msg_font;
	STRING	nullstring;
}

TEXT panel_msg {
	POS_X 	130;
	POS_Y 	349;
	FONT		msg_font;
	STRING	nullstring;
}

/////////////////////////////////////////////////////////
BMAP	compass,<skafonts.lbm>,0,83,160,22;
OVLY	grey_cross,<skafonts.lbm>,60,106,60,44;

BMAP	brainout,<raum3_r.pcx>;
PALETTE picture_pal { PALFILE <raum3_r.pcx>; }

PALETTE green_pal { PALFILE <green.bbm>;
	RANGE 16,16;	RANGE 32,16;	RANGE 48,32;	RANGE 80,32;
	RANGE 112,16;	RANGE 128,16;	RANGE 144,32;
	RANGE 176,16;	RANGE 192,16;	RANGE 208,16;	RANGE 224,16;
	RANGE 240,4;	RANGE	244,6;
}
PALETTE matmapal { PALFILE <matmapal.bbm>;
	RANGE 16,16;	RANGE 32,16;	RANGE 48,32;	RANGE 80,32;
	RANGE 112,16;	RANGE 128,16;	RANGE 144,32;
	RANGE 176,16;	RANGE 192,16;	RANGE 208,16;	RANGE 224,16;
	RANGE 240,4;	RANGE	244,6;
}
PALETTE red_pal { PALFILE <red.bbm>; }
PALETTE black_pal { PALFILE <black.bbm>;
	RANGE 16,16;	RANGE 32,16;	RANGE 48,32;	RANGE 80,32;
	RANGE 112,16;	RANGE 128,16;	RANGE 144,32;
	RANGE 176,16;	RANGE 192,16;	RANGE 208,16;	RANGE 224,16;
	RANGE 240,4;	RANGE	244,6;
}	// letzte palette!!
PALETTE pal1 { PALFILE <skafonts.lbm>;
	RANGE 16,16;	RANGE 32,16;	RANGE 48,32;	RANGE 80,32;
	RANGE 112,16;	RANGE 128,16;	RANGE 144,32;
	RANGE 176,16;	RANGE 192,16;	RANGE 208,16;	RANGE 224,16;
	RANGE 240,4;	RANGE	244,6;
	FLAGS	BLUR;
}
/////////////////////////////////////////////////////////
///////////////////////////////////////////////////////
// Panels
/////////////////////////////////////////////////////////
SKILL counter		{ VAL 0; MIN 0; }
SKILL fwd_force	{ MIN 0; MAX 5; 	}
SKILL bkwd_force	{ MIN 0; MAX 5; 	}
SKILL show_speed	{}
SKILL blink_count	{ VAL 0;	}
SKILL e_count		{ VAL 0;	}

SKILL skatomic { VAL 0; }
SKILL skajet	{ VAL 0; }
SKILL skanex	{ VAL 0; }
SKILL skaful	{ VAL 0; }

SKILL red_fade 	{ MAX 0.8; }
SKILL old_fade 	{ MAX 0.8; }
SKILL diff_vz		{ VAL 0;	}
SKILL old_vz		{ VAL 0;	}
SKILL last_gndz	{ VAL 0;	}
SKILL vz_fac	 	{ 	}
SKILL matma_fac	{ 	}
SKILL	fps			{}
SKILL	svol 			{ VAL 0; MIN 0; MAX 0.3; }
SKILL gas			{ VAL 0.3; MIN 0;	}
SKILL gas1			{ VAL 0.3; MIN 0;	}
SKILL damage		{ VAL 0;		}

SKILL WALK_PERIOD { VAL 1; }
SKILL WAVE_PERIOD { VAL 5; }
SKILL PSOUND_TONE	{ VAL 1; MIN 0.5; MAX 1.3; }
SKILL PSOUND_VOL	{ VAL 1; MIN 0; MAX 0.8; }

ACTION skaph_panel	{
	RULE  fwd_force	= FORCE_AHEAD;
	RULE  bkwd_force	= -FORCE_AHEAD;
#	RULE  show_speed	= 0.5*show_speed + 0.5*REAL_SPEED;
	RULE  show_speed	= REAL_SPEED;
	RULE  fps			= 0.7*fps + 0.3*TIME_FAC;
	RULE  val1			= -0.02*fwd_force + -0.02*bkwd_force + -0.1*rocket_up;
	RULE  energy		= energy + val1*TIME_CORR;
	RULE  diff_vz		= (PLAYER_VZ - old_vz)*TIME_FAC;
	RULE  vz_fac		= diff_vz*diff_vz;
	RULE  old_vz		= PLAYER_VZ;
	RULE  matma_fac	= -0.2*TIME_CORR*floor_depth;
	RULE  old_shield	= shield;
	RULE  shield		= shield + matma_fac;

	RULE  svol			= rocket_up*0.3;
	RULE  gas1			= show_speed;
	RULE  gas			= -show_speed;
	RULE  gas			= gas + gas1;
	RULE  PSOUND_TONE	= 0.9 + gas*0.1;

	SET		PSOUND_VOL,0;
	IF_BELOW	gas,0.01;
		GOTO	pan_nosnd;
	IF_ABOVE	PLAYER_HGT,0.2;
		GOTO	pan_nosnd;	// Kein Fahrgeraeusch bei Spruengen
	RULE		PSOUND_VOL	= 0.04 + 0.06*gas + 0.09*fwd_force + 0.07*bkwd_force;
pan_nosnd:

	IF_ABOVE	rocket_up,0.1;
		PLAY_SOUND	booster,svol;

	IF_BELOW	energy,1;
		SET	FORCE_UP,0;

	SET		MAP_MODE,0;
	IF_EQUAL	KEY_TAB,0;
		GOTO	pan_nomap;
	IF_EQUAL	service_mode,1;
		GOTO	pan_nomap;
	SET		MAP_MODE,0.5;
	IF_ABOVE	god,0;
		SET	MAP_MODE,1;
	IF_EQUAL	KEY_SZ,1;
		RULE	MAP_SCALE = MAP_SCALE*0.95;
	IF_EQUAL	KEY_MINUS,1;
		RULE	MAP_SCALE = MAP_SCALE*0.95;
	IF_EQUAL	KEY_APO,1;
		RULE	MAP_SCALE = MAP_SCALE*1.05;
	IF_EQUAL	KEY_PLUS,1;
		RULE	MAP_SCALE = MAP_SCALE*1.05;
pan_nomap:

	ADD		blink_count,TIME_CORR;
	IF_ABOVE	blink_count,24;
		SET	blink_count,0;

// Crash bei Aufschlag
	IF_BELOW	PLAYER_Z,HERE.FLOOR_HGT;
		GOTO	pan_crash;
	IF_BELOW	vz_fac,0.1;
		GOTO	pan_nocrash;
	PLAY_SOUND	rrumms,0.2;
	IF_BELOW	vz_fac,0.7;
		GOTO	pan_nocrash;
	PLAY_SOUND	rrumms,0.4;
pan_crash:
	RULE	health = health + -30*vz_fac;
	SUB		last_gndz,PLAYER_Z;	// Absturzhoehe
	IF_ABOVE	last_gndz,65;
		SET	health,0;
pan_nocrash:
	IF_BELOW	PLAYER_VZ,-0.05;
		SKIP	2;
	IF_BELOW	PLAYER_HGT,0.2;
		SET	last_gndz,PLAYER_Z;	// letztes Z bei boden unter den Fuessen

	IF_ABOVE	shield,0;
		SKIP	2;
	IF_EQUAL	HERE.FLAG5,0;	// unter Matma?
		ADD	health,matma_fac;

	SET		damage,0;	// normal
	IF_NEQUAL	moving,4;	// rocket?
		GOTO	no_rocket;
	SET		damage,4;
	SET		shield,0;
	SET		old_shield,0;
no_rocket:
	IF_EQUAL	old_shield,0;
		GOTO	no_shield;
	SET		damage,1;	// shield
	IF_EQUAL	shield,0;	// shield verbraucht?
		CALL	shield_weg;
no_shield:

	IF_ABOVE	health,75;
		GOTO	pan_nodam;
	SET		damage,3;	// konstant rot
	IF_ABOVE	health,50;
		GOTO	pan_nodam;
	IF_ABOVE	blink_count,16;
		GOTO	pan_nodam;
	SET		damage,9;	// schwarz/rot blinken
	IF_EQUAL blink_count,0;
		PLAY_SOUND	alarm,0.4;
pan_nodam:

	RULE		red_fade=0.02*old_health + -0.02*health;
	SET		old_health,health;
	IF_EQUAL	red_fade,old_fade;
		GOTO	pan_nodam2;
	SET		old_fade,red_fade;
	FADE_PAL	red_pal,red_fade;
pan_nodam2:

	IF_EQUAL	god,0;
		GOTO	pan_nogod;
	SET		energy,energy.MAX;
	SET		health,health.MAX;
pan_nogod:

// Low energy
	IF_ABOVE blink_count,0;
		GOTO	no_elow;
	IF_BELOW health,50;
		GOTO	no_elow;
	IF_BELOW	energy,50;
		PLAY_SOUND	energy_low,0.4;
no_elow:

	IF_BELOW health,1;
		BRANCH		skaph_die;
	IF_ABOVE energy,0.9;
		END;

	RULE		health = health + energy - 0.9;
	SET		energy,0.9;
	SET		PLAYER_VX,0;
	SET		PLAYER_VY,0;
	SET		ahead_speed,0;
}

ACTION shield_weg {
	SET 	screen_msg.STRING,shield_wegtxt;
	SET 	EACH_TICK.14,show_message;
}

ACTION skaph_sec {
	ADD 		counter,1;
}

ACTION flash_off {
	WAIT		1;
	FADE_PAL	red_pal,0;
	SET		EACH_TICK.12,NULL;
}
///////////////////////////////////////////////

FONT	debug_font,<pantfont.lbm>,8,10;
PANEL debug_panel {
	POS_X		0;	POS_Y		0;
	DIGITS	20,4,3,debug_font,160,fps;
	DIGITS	50,4,2,debug_font,1,ACTIVE_NEXUS;
	DIGITS	80,4,2,debug_font,1,ACTIVE_OBJTICKS;
	DIGITS	110,4,2,debug_font,10,debug_1;

	DIGITS	160,4,1,debug_font,1,CHANNEL_0;
	DIGITS	170,4,1,debug_font,1,CHANNEL_1;
	DIGITS	180,4,1,debug_font,1,CHANNEL_2;
	DIGITS	190,4,1,debug_font,1,CHANNEL_3;
	DIGITS	200,4,1,debug_font,1,CHANNEL_4;
	DIGITS	210,4,1,debug_font,1,CHANNEL_5;
	DIGITS	220,4,1,debug_font,1,CHANNEL_6;
	DIGITS	230,4,1,debug_font,1,CHANNEL_7;

#	DIGITS	160,4,4,debug_font,1,coni_pos;
#	DIGITS	200,4,4,debug_font,1,debug_1;
#	DIGITS	240,4,4,debug_font,10,debug_3;	//last_player;
#	DIGITS	280,4,4,debug_font,1,debug_4;	//last_slot;
#	DIGITS	280,2,4,debug_font,1,counter;
}
///////////////////////////////////////////////


SKILL	SCREEN_X			{ VAL 24;	}
SKILL	SCREEN_Y			{ VAL 14;	}
SKILL	SCREEN_WIDTH	{ VAL 272;	}
SKILL	SCREEN_HGT		{ VAL 318;	}

SKILL	MAP_EDGE_X1 { VAL 24;  }
SKILL MAP_EDGE_Y1 { VAL 16;  }
SKILL MAP_EDGE_X2 { VAL 296; }
SKILL MAP_EDGE_Y2 { VAL 332; }


FONT	led,<zahlreih.bbm>,10,22;
FONT	skaph_font,<skaphs.bbm>,28,33;

BMAP	full_cockpit,<SKAPHBPA.LBM>;
OVLY	blit_cockpit,<SKAPHBPA.LBM>,24,16,272,316;
BMAP	pleer_bmp,<SKAPHBPA.LBM>,124,347,32,34;

OVERLAY cockpit	{ POS_X 24; POS_Y 16; FLAGS ABSPOS; OVLYS blit_cockpit; }
PANEL	pleer_pan	{ POS_X 124; POS_Y 347; PAN_MAP pleer_bmp; }

PANEL panel_a {
	POS_X		0;	POS_Y		0;
	PAN_MAP	full_cockpit;
#	DIGITS	16,366,4,led,40,show_speed;
	DIGITS	15,366,4,led,1,points;
	HBAR		73,359,40,compass,-19.1,PLAYER_ANGLE;
	DIGITS	169,347,1,skaph_font,1,damage;
	DIGITS	219,359,3,led,1,health;
	DIGITS	277,366,3,led,1,energy;
}

////////////////////////////////////////////////
// Waffen
OVLY	cannon1_0,<canon1.LBM>,0,0,68,82;
OVLY	cannon1_1,<canon1.LBM>,68,0,68,80;	//-2
OVLY	cannon1_2,<canon1.LBM>,136,0,68,79;	//-3
OVLY	cannon1_3,<canon1.LBM>,204,0,68,80;	//-2
OVLY	cannon1_4,<canon1.LBM>,0,82,68,81;	//-1
OVLY	cannon1_5,<canon1.LBM>,68,82,68,82;
OVLY	cannon1_6,<canon1.LBM>,136,82,68,82;

OVLY	cannonr1_0,<t_canon1.LBM>,252,0,68,82;
OVLY	cannonr1_1,<t_canon1.LBM>,184,0,68,80;
OVLY	cannonr1_2,<t_canon1.LBM>,116,0,68,79;
OVLY	cannonr1_3,<t_canon1.LBM>,48,0,68,80;
OVLY	cannonr1_4,<t_canon1.LBM>,252,82,68,81;
OVLY	cannonr1_5,<t_canon1.LBM>,184,82,68,82;
OVLY	cannonr1_6,<t_canon1.LBM>,116,82,68,82;

OVERLAY	icrosshair { POS_X 130; POS_Y 154; FLAGS ABSPOS; OVLYS grey_cross; }
#OVERLAY	crosshair { POS_X 106; POS_Y 144; OVLYS red_cross; }

OVERLAY	cannon0 { POS_X 27; POS_Y 250; FLAGS ABSPOS; OVLYS cannon1_0; }
OVERLAY	cannon1 { POS_X 25; POS_Y 252; FLAGS ABSPOS; OVLYS cannon1_1; }
OVERLAY	cannon2 { POS_X 24; POS_Y 253; FLAGS ABSPOS; OVLYS cannon1_2; }
OVERLAY	cannon3 { POS_X 25; POS_Y 252; FLAGS ABSPOS; OVLYS cannon1_3; }
OVERLAY	cannon4 { POS_X 26; POS_Y 251; FLAGS ABSPOS; OVLYS cannon1_4; }
OVERLAY	cannon5 { POS_X 27; POS_Y 250; FLAGS ABSPOS; OVLYS cannon1_5; }
OVERLAY	cannon6 { POS_X 27; POS_Y 250; FLAGS ABSPOS; OVLYS cannon1_6; }

OVERLAY	cannonr0 { POS_X 228; POS_Y 250; FLAGS ABSPOS; OVLYS cannonr1_0; }
OVERLAY	cannonr1 { POS_X 230; POS_Y 252; FLAGS ABSPOS; OVLYS cannonr1_1; }
OVERLAY	cannonr2 { POS_X 231; POS_Y 253; FLAGS ABSPOS; OVLYS cannonr1_2; }
OVERLAY	cannonr3 { POS_X 230; POS_Y 252; FLAGS ABSPOS; OVLYS cannonr1_3; }
OVERLAY	cannonr4 { POS_X 229; POS_Y 251; FLAGS ABSPOS; OVLYS cannonr1_4; }
OVERLAY	cannonr5 { POS_X 228; POS_Y 250; FLAGS ABSPOS; OVLYS cannonr1_5; }
OVERLAY	cannonr6 { POS_X 228; POS_Y 250; FLAGS ABSPOS; OVLYS cannonr1_6; }

BMAP	leermap,<knallig.lbm>,0,0,1,1;

BMAP	flash_1,<knallig.lbm>,0,0,16,16;
BMAP	flash_2,<knallig.lbm>,16,0,16,16;
BMAP	flash_3,<knallig.lbm>,32,0,16,16;
BMAP	flash_4,<knallig.lbm>,48,0,16,16;

BMAP	wolke_1,<knallig.lbm>,124,0,20,20;
BMAP	wolke_2,<knallig.lbm>,144,0,20,20;
BMAP	wolke_3,<knallig.lbm>,164,0,20,20;
BMAP	wolke_4,<knallig.lbm>,184,0,20,20;
BMAP	wolke_5,<knallig.lbm>,204,0,20,20;

BMAP	flblue_1,<knallig.lbm>,292,172,24,25;
BMAP	flblue_2,<knallig.lbm>,316,172,24,25;
BMAP	flblue_3,<knallig.lbm>,340,172,24,25;
BMAP	flblue_4,<knallig.lbm>,364,172,24,25;
BMAP	flblue_5,<knallig.lbm>,388,172,24,25;

TEXTURE	leer_tex { BMAPS	leermap; }

TEXTURE	flash_tex {
	SCALE_XY	16,16;
	CYCLES	4;
	BMAPS		flash_1,flash_2,flash_3,flash_4;
	DELAY		1,1,1,1;
	FLAGS		ONESHOT;
	AMBIENT	1;
}

TEXTURE	flblue_tex {
	SCALE_XY	16,16;
	CYCLES	5;
	BMAPS		flblue_1,flblue_2,flblue_3,flblue_4,flblue_5;
	DELAY		1,1,1,1,1;
	FLAGS		ONESHOT;
	AMBIENT	1;
}

TEXTURE	wolke_tex {
	SCALE_XY	12,12;
	CYCLES	5;
	BMAPS		wolke_1,wolke_2,wolke_3,wolke_4,wolke_5;
	DELAY		2,2,2,2,2;
	FLAGS		ONESHOT;
	AMBIENT	0.5;
}

ACTOR	flash {
	TEXTURE		flash_tex;
	FLAGS			GROUND,INVISIBLE,PASSABLE;
}

ACTOR	flash2 {
	TEXTURE		flash_tex;
	FLAGS			GROUND,INVISIBLE,PASSABLE;
}

ACTOR	flash3 {
	TEXTURE		flash_tex;
	FLAGS			GROUND,INVISIBLE,PASSABLE;
}

ACTOR	flash4 {
	TEXTURE		flash_tex;
	FLAGS			GROUND,INVISIBLE,PASSABLE;
}

/////////////////////////////////////////////////////////////
SKILL	gun_strength	{ VAL 0; }
SKILL	gun_wait			{ MIN 0;	}
SKILL last_hitdist	{ VAL 0; MIN 1; }
SKILL last_hitmode	{ VAL 0; }
SKILL last_playerz	{ VAL 0; }

ACTION tu_nix {
	SET	EACH_TICK.13,NULL;
}

ACTION set_gun0 {
	SET	EACH_TICK.13,NULL;
	SET	LAYERS.1,NULL;
	SET	LAYERS.2,NULL;
	SET	LAYERS.3,NULL;
	SET	LAYERS.4,NULL;
	SET	LAYERS.5,NULL;
	SET	LAYERS.6,NULL;
	SET	gun_type,0;
	SET	fire,tu_nix;
	SET	set_gun,tu_nix;
}
ACTION set_gun1 {
	IF_EQUAL	gun1,0;
		BRANCH	set_gun0;
	SET	EACH_TICK.13,NULL;
	SET	LAYERS.1,cannon0;
	SET	LAYERS.2,NULL;
	SET	LAYERS.3,NULL;
	SET	LAYERS.4,NULL;
	SET	LAYERS.5,NULL;
	SET	LAYERS.6,icrosshair;
	SET	gun_type,1;
	SET	fire,fire1;
	SET	set_gun,set_gun1;
}
ACTION set_gun2 {
	IF_EQUAL	gun2,0;
		BRANCH	set_gun1;
	SET	EACH_TICK.13,NULL;
	SET	LAYERS.1,cannon0;
	SET	LAYERS.2,cannonr0;
	SET	LAYERS.3,NULL;
	SET	LAYERS.4,NULL;
	SET	LAYERS.5,NULL;
	SET	LAYERS.6,icrosshair;
	SET	gun_type,2;
	SET	fire,fire2;
	SET	set_gun,set_gun2;
}

ACTION fire_start {
	IF_BELOW	energy,1;
		END;
	IF_BELOW	gun_type,1;
		END;
	IF_ABOVE	underwater,0;	// unter Wasser nicht feuern
		END;
	IF_BELOW	gun_type,5;
		SET	LAYERS.6,icrosshair;
	SET		EACH_TICK.13,fire;
}


ACTION fire_stop {
#	SET	LAYERS.6,icrosshair;
	SET	EACH_TICK.13,NULL;
}

ACTION init_flash {
	SET	MY.TEXTURE,flash_tex;
	IF_EQUAL	HIT.FRAGILE,1;		// Virus getroffen?
		SET	MY.TEXTURE,flblue_tex;
	SET	MY.PLAY,1;
	SET	MY.PASSABLE,1;
	SET	MY.CAREFULLY,0;
	SET	MY.DIST,last_hitdist;
	ADD	MY.DIST,-0.5;
	RULE	val1 = -0.83*last_hitdist;
	RULE	val1 = PLAYER_Z + val1*PLAYER_TILT + 0.4*RANDOM + -1.2;
	SET	MY.HEIGHT,val1;
	SET	MY.TARGET,DROP;

	SET	MY.SPEED,0.3;
	SET	MY.TARGET,FOLLOW;
	SET	MY.EACH_TICK,NULL;
	SET	MY.EACH_CYCLE,init_wolke;
}

ACTION init_wolke {
	SET	SHOOT_FAC,0;
	SET	SHOOT_RANGE,40;
	EXPLODE	MY;				// Viren im Umkreis alarmieren

	SET	MY.SPEED,0.3;
	RULE	val1 = 0.3*TIME_CORR;
	SET	MY.SKILL8,val1;
	ADD	MY.HEIGHT,0.3;
	SET	MY.TEXTURE,wolke_tex;
	SET	MY.PLAY,1;
	SET	MY.EACH_TICK,flash_auf;
	SET	MY.EACH_CYCLE,flash_weg;
}

ACTION flash_auf {
	ADD	MY.HEIGHT,MY.SKILL8;
}

ACTION flash_weg {
	SET	MY.INVISIBLE,1;
}


ACTION fire1 {
	SET		gun_wait,TICKS;
	PLAY_SOUND	twaeng,0.6,-0.7;
	SET		LAYERS.1,cannon1;
	ADD		PLAYER_LIGHT,0.6;
	ADD		ahead_speed,-0.1;	// Rueckstoss
	ADD		tilt_speed,-0.03;
	ADD		PLAYER_VROT,0.05;	// Drall
	SET		gun_strength,-100;
	SET 		SHOOT_RANGE,100;
	SET		SHOOT_FAC,1;
	SHOOT;
	IF_EQUAL	HIT_DIST,0;
		GOTO	fire1_daneben;
	SET		last_hitdist,HIT_DIST;

	IF_EQUAL flash.INVISIBLE,0;	// flash 1 noch unterwegs?
		SKIP	3;
	SET		flash.INVISIBLE,0;
	SET		flash.EACH_TICK,init_flash;
	SKIP		12;
	IF_EQUAL flash2.INVISIBLE,0;
		SKIP	3;
	SET		flash2.INVISIBLE,0;
	SET		flash2.EACH_TICK,init_flash;
	SKIP		7;
	IF_EQUAL flash3.INVISIBLE,0;
		SKIP	3;
	SET		flash3.INVISIBLE,0;
	SET		flash3.EACH_TICK,init_flash;
	SKIP		2;
	SET		flash4.INVISIBLE,0;
	SET		flash4.EACH_TICK,init_flash;

fire1_daneben:
	WAIT		1;
	SET		LAYERS.1,cannon2;
	SET		PLAYER_LIGHT,my_light;
	RULE		energy = energy + -1;
	IF_BELOW	energy,1;
		GOTO	fire1_end;
	WAIT		1;
	SET		LAYERS.1,cannon3;
	IF_ABOVE	TIME_CORR,1.3;
		SKIP	2;
	WAIT		1;
	SET		LAYERS.1,cannon4;
	WAIT		1;
	SET		LAYERS.1,cannon5;
	IF_ABOVE	TIME_CORR,1.7;
		SKIP	2;
	WAIT		1;
	SET		LAYERS.1,cannon6;
	WAIT		1;
	SET		LAYERS.1,cannon0;
	RULE		gun_wait = gun_wait + -1*TICKS + 10;
	WAITT		gun_wait;
	IF_EQUAL	KEY_CTRL,1;
		END;
	IF_EQUAL	MOUSE_LEFT,1;
		END;
fire1_end:
	SET		LAYERS.1,cannon0;
	BRANCH			fire_stop;
}

ACTION fire2 {
	SET		gun_wait,TICKS;
	PLAY_SOUND	twaeng,0.6,0.7;
	SET		LAYERS.2,cannonr1;
	ADD		PLAYER_LIGHT,0.6;
	ADD		ahead_speed,-0.1;	// Rueckstoss
	ADD		tilt_speed,-0.03;
	SET		gun_strength,-120;
	SET	 	SHOOT_RANGE,100;
	SET		SHOOT_FAC,1;
	SHOOT;
	IF_EQUAL	HIT_DIST,0;
		GOTO	fire2_daneben1;
	SET		last_hitdist,HIT_DIST;

	IF_EQUAL flash.INVISIBLE,0;	// flash 1 noch unterwegs?
		SKIP	3;
	SET		flash.INVISIBLE,0;
	SET		flash.EACH_TICK,init_flash;
	SKIP		12;
	IF_EQUAL flash2.INVISIBLE,0;
		SKIP	3;
	SET		flash2.INVISIBLE,0;
	SET		flash2.EACH_TICK,init_flash;
	SKIP		7;
	IF_EQUAL flash3.INVISIBLE,0;
		SKIP	3;
	SET		flash3.INVISIBLE,0;
	SET		flash3.EACH_TICK,init_flash;
	SKIP		2;
	SET		flash4.INVISIBLE,0;
	SET		flash4.EACH_TICK,init_flash;

fire2_daneben1:
	WAIT		1;
	SET		LAYERS.2,cannonr2;
	SET		PLAYER_LIGHT,my_light;
	RULE		energy = energy + -1;
	IF_BELOW	energy,1;
		GOTO	fire2_end;
	IF_ABOVE	TIME_CORR,1.7;
		SKIP	2;
	WAIT		1;
	SET		LAYERS.2,cannonr3;
	WAIT		1;
	PLAY_SOUND	twaeng,0.6,-0.7;
	SET		LAYERS.1,cannon1;
	SET		LAYERS.2,cannonr4;
	ADD		PLAYER_LIGHT,0.6;
	ADD		ahead_speed,-0.1;	// Rueckstoss
	ADD		tilt_speed,-0.03;
	SET		gun_strength,-120;
	SET 		SHOOT_RANGE,100;
	SET	 	SHOOT_RANGE,100;
	SHOOT;
	IF_EQUAL	HIT_DIST,0,fire2_daneben2;
	SET		last_hitdist,HIT_DIST;

	IF_EQUAL flash.INVISIBLE,0;	// flash 1 noch unterwegs?
		SKIP	3;
	SET		flash.INVISIBLE,0;
	SET		flash.EACH_TICK,init_flash;
	SKIP		12;
	IF_EQUAL flash2.INVISIBLE,0;
		SKIP	3;
	SET		flash2.INVISIBLE,0;
	SET		flash2.EACH_TICK,init_flash;
	SKIP		7;
	IF_EQUAL flash3.INVISIBLE,0;
		SKIP	3;
	SET		flash3.INVISIBLE,0;
	SET		flash3.EACH_TICK,init_flash;
	SKIP		2;
	SET		flash4.INVISIBLE,0;
	SET		flash4.EACH_TICK,init_flash;

fire2_daneben2:
	IF_ABOVE	TIME_CORR,1.2;
		SKIP	3;
	WAIT		1;
	SET		LAYERS.1,cannon2;
	SET		LAYERS.2,cannonr5;
	SET		PLAYER_LIGHT,my_light;
	RULE		energy = energy + -1;
	IF_BELOW	energy,1,fire2_end;
	WAIT		1;
	SET		LAYERS.1,cannon3;
	IF_ABOVE	TIME_CORR,1.5;
		SKIP	3;
	SET		LAYERS.2,cannonr6;
	WAIT		1;
	SET		LAYERS.1,cannon4;
	SET		LAYERS.2,cannonr0;
	WAIT		1;
	SET		LAYERS.1,cannon5;
	IF_ABOVE	TIME_CORR,1.9;
		SKIP	2;
	WAIT		1;
	SET		LAYERS.1,cannon6;
	WAIT		1;
	SET		LAYERS.1,cannon0;
	RULE		gun_wait = gun_wait + -1*TICKS + 10;
	WAITT		gun_wait;
	IF_EQUAL	KEY_CTRL,1;
		END;
	IF_EQUAL	MOUSE_LEFT,1;
		END;
fire2_end:
	SET		LAYERS.1,cannon0;
	SET		LAYERS.2,cannonr0;
	BRANCH			fire_stop;
}



//////////////////////////////////////////////////////////////
// Virus-Routinen
SKILL	vhit_force 	{}	// Virus-Trefferwirkung
SKILL	hit_force 	{}	// Player-Trefferwirkung
SKILL	attacking	{ VAL 0; }
SKILL	vir_dist		{}
SKILL virus_dir	{ VAL 1; }	// letzte ausweich-richtung

/*
ACTION unflash {
	WAIT		1;
	FADE_PAL	red_pal,0;
	ADD		PLAYER_LIGHT,my_light;
	SET		MY.EACH_TICK,NULL;
}
*/
ACTION virus_init	{
	IF_BELOW	difficulty,0;		// noch nicht gewaehlt?
		END;
	SET		MY.INVISIBLE,1;
	IF_ABOVE	MY.SKILL5,difficulty;
		END;
	SET		MY.INVISIBLE,0;
	ADD		virenquote,1;
	SET		MY.EACH_TICK,NULL;
	SET		MY.EACH_CYCLE,NULL;
	IF_EQUAL	MY.FLAG5,0;			// Absolute Hoehe, wenn kein FLAG5 gesetzt
		SET	MY.GROUND,1;
	SET		MY.PASSABLE,0;		// wg. rebirth
	SET		MY.RESULT,0;
	SET		MY.FRAGILE,1;		// Reagiert auf EXPLODE
}

ACTION virus_wait	{
	ADD		MY.DIST,2;	// Hysterese
	SET	 	MY.SPEED,0.3;
	SET		MY.TARGET,REPEL;
}

ACTION virus_run	{
	ADD		MY.DIST,-2;	// Hysterese
	SET		MY.SPEED,0.7;
	SET		MY.TARGET,FOLLOW;
}


ACTION virus_explode {
	SET		MY.EACH_CYCLE,virus_weg;
	SET		MY.CAREFULLY,0;	// nur dann, wenn kein Virenrest bleibt!!
	BRANCH	rest_explode;
}

ACTION rest_explode {
	ADD		points,MY.SKILL4;
	ADD		abschussquote,1;
	SET		MY.PLAY,1;
	SET		MY.dead,1;
	SET		MY.PASSABLE,1;
	SET		MY.TARGET,FOLLOW;
	SET		MY.SPEED,0.3;
	SET		MY.VSPEED,0.1;
	SET		MY.IF_NEAR,NULL;
	SET		MY.IF_FAR,NULL;
	SET		MY.IF_HIT,NULL;
	ADD		THERE.AMBIENT,0.3;	// Light up region
	WAITT		6;
	ADD		THERE.AMBIENT,-0.3;
}

ACTION virus_weg {
	SET		MY.EACH_CYCLE,NULL;
	SET		MY.INVISIBLE,1;
}

ACTION set_vspeed {	// vertikale Viren-Bewegung auf Player zu
	SET		val1,MY.HEIGHT;
	IF_EQUAL	MY.GROUND,0;
		ADD	val1,THERE.FLOOR_HGT;
	SET		val2,MY.SIZE_Y;
	RULE		val1 = val1 + 0.5*val2 + -1*PLAYER_Z;	// Hoehendifferenz
	SET		MY.VSPEED,0;
 	IF_ABOVE val1,1;
		SET	MY.VSPEED,-0.1;
 	IF_BELOW val1,-2;
		SET	MY.VSPEED,0.1;
}

ACTION virus_hit {
	IF_EQUAL	SHOOT_RANGE,14;	// manipulation?
		SET	RESULT,0;
	SET		vhit_force,0;
	IF_ABOVE	RESULT,0;	// Treffer von Player oder Mine?
		RULE	vhit_force = (RESULT+0.3)*gun_strength;
	ADD		MY.armor,vhit_force;
}

ACTION player_hit {	// erwartet RESULT + hit_force!
	RULE		RESULT = 0.9*RESULT + 0.1;
	IF_MIN	shield;
		GOTO	no_shield;
	RULE		shield = shield + RESULT*hit_force;
	RULE		RESULT = 0.5*RESULT;
no_shield:
	RULE		health = health + RESULT*hit_force;
	RULE		RESULT = 0.3*RESULT + 0.1;
	PLAY_SOUND	tschok,RESULT;
	SET		RESULT,0;
}

////////////////////////////////////////////////
// Message-Aktionen:
// STRING my_string,"Dies ist ein Teststring!";
// SET 	screen_msg.STRING,my_string;
// CALL 	show_message;

ACTION show_text {
#	SET		LAYERS.16,NULL;
	BRANCH			show_message;
}

ACTION show_panel {
	SET		MESSAGES.15,panel_msg;
	IF_EQUAL	message_delay,0;	// keine message unterwegs?
		SET	message_delay,3;	//
	SET		EACH_TICK.14,count_message;
}

ACTION clear_panel {
	SET		PANELS.14,pleer_pan;
	SET		message_delay,2;
	SET		EACH_TICK.14,count_message;
}

ACTION show_message {
	SET		MESSAGES.16,screen_msg;
	IF_EQUAL	message_delay,0;
		SET	message_delay,80;	// 5-Sekunden-Message
	SET		EACH_TICK.14,count_message;
}

ACTION count_message {
	ADD		message_delay,time_dec;
	IF_ABOVE	message_delay,0;
		END;
	BRANCH			clear_message;
}

ACTION clear_message {
#	SET		LAYERS.16,NULL;
	SET		MESSAGES.15,NULL;
	SET		MESSAGES.16,NULL;
	SET		PANELS.14,NULL;
	SET		EACH_TICK.14,NULL;
	SET 		screen_msg.STRING,nullstring;
	SET		message_delay,0;
	IF_EQUAL	freeze,0;
		SET	MOVE_MODE,1;			// Abbrechen
	IF_EQUAL	service_mode,1;
		SET	MOVE_MODE,0.5;
	SET		IF_Y,NULL;
	SET		IF_Z,NULL;
}


ACTION wait_yesno {
	SET		MESSAGES.16,screen_msg;
	SET		MOVE_MODE,0.5;			// Einfrieren
	SET		EACH_TICK.14,NULL;
	SET		IF_N,clear_message;
	SET		IF_ESC,back_to_game;
}

ACTION back_to_game {
	BRANCH			clear_message;
}

//////////////////////////////////////////////////////////////
// Objekte
BMAP	battery, <objects.lbm>,79,0,38,64;
BMAP  big_akku, <objects.lbm>,120,0,101,76;
BMAP	screw, <objects.lbm>,272,2,44,82;

TEXTURE	screw_tex {
	SCALE_XY	32,32;
	BMAPS		screw;
	AMBIENT	0.2;
}
TEXTURE	battery_tex {
	SCALE_XY	32,32;
	BMAPS		battery;
	AMBIENT	0.2;
}
TEXTURE	big_akku_tex {
	SCALE_XY	44,44;
	BMAPS		big_akku;
	AMBIENT	0.2;
}


THING	screwdriver {
	TEXTURE	screw_tex;
	IF_NEAR	screw_up;
	IF_HIT	thing_hit;
}
THING	batterie1 {
	TEXTURE	battery_tex;
	IF_NEAR	battery_up1;
	IF_HIT	thing_hit;
}

THING	sixpack {
	TEXTURE	big_akku_tex;
	IF_NEAR	akku_up1;
	IF_HIT	thing_hit;
}

ACTION thing_hit {
#	SET		MY.INVISIBLE,1;
	IF_ABOVE	SHOOT_RANGE,14;
		END;
#	SET		MY.INVISIBLE,0;
	SET	 	MY.EACH_TICK,MY.IF_NEAR;
}

ACTION	screw_up {
	SET		MY.invisible, 1 ;
	PLAY_SOUND	klonk,0.3;
	RULE		health = health + 25;
	SET 		screen_msg.STRING,got_spanner;
	BRANCH 		show_text;
}
ACTION	battery_up1 {
	SET		MY.invisible, 1 ;
	RULE		energy = energy + 25;
	PLAY_SOUND	Beamer,0.2;
	SET 		screen_msg.STRING,got_battery;
   BRANCH 		show_text;
}
ACTION	akku_up1 {
	SET		MY.invisible, 1 ;
	RULE		energy = energy + 150;
	PLAY_SOUND	Beamer,0.4;
	SET 		screen_msg.STRING,got_6;
	BRANCH 		show_text;
}

////////////////////////////////////////////////////////
// Tank/Repair-Aktionen
// Achtung!! Jede Tank/Repair-Wand braucht individuellen Namen!!
SKILL	fuel {}
SKILL	repair	{ VAL 0; }
SKILL old_dist		{}
SKILL	drown_count	{ VAL 0; }

ACTION fuel_refill {
	IF_BELOW	MY.SKILL5,0;	// leergesaugt?
		END;
	IF_ABOVE	energy,290;
		END;
	SET		MY.EACH_TICK,suck_fuel;
	BRANCH			start_refill;
}

ACTION health_refill {
	IF_BELOW	MY.SKILL5,0;	// leergesaugt?
		END;
	IF_ABOVE	drown_count,0;	// haengt whopper dran?
		SKIP	2;
	IF_ABOVE	health,390;
		END;
	SET		repair,1;		// Fuer whopper
	SET		MY.EACH_TICK,suck_health;
	BRANCH			start_refill;
}

ACTION start_refill {
	SET		fuel,5;			// Wait-counter
	ADD		MY.DIST,10;		// Hysterese
	SET		i_fric,1;
	SET		xy_fric,1;
	SET		a_fric,0.6;
}

ACTION catch_drift {
	RULE drift_x	= 0.1*drift_x + -0.2*PLAYER_X;
	RULE drift_y	= 0.1*drift_y + -0.2*PLAYER_Y;
	RULE fuel		= fuel + time_dec;
}

ACTION suck_fuel {
	SET		drift_x,MY.SKILL1;
	SET		drift_y,MY.SKILL2;
	CALL 		catch_drift;
	IF_ABOVE	fuel,0;	// noch warten?
		END;

	PLAY_SOUND klonk,0.2;
	ADD		MY.SKILL5,time_dec;
	RULE		val1 = TIME_CORR * 0.128;
	ADD		MY.OFFSET_Y,val1;
	IF_BELOW	MY.SKILL5,0;	// leergesaugt?
		BRANCH		stop_refill;
	RULE		energy = energy + TIME_CORR;
	IF_MAX	energy;
		BRANCH	stop_refill;
}

ACTION stop_refill {
	SET		repair,0;		// Fuer whopper
	PLAY_SOUND alarm, 0.4;
	IF_ABOVE	drift_x,0;
		ADD	PLAYER_VX,-1;
	IF_BELOW	drift_x,0;
		ADD	PLAYER_VX,1;
	IF_ABOVE	drift_y,0;
		ADD	PLAYER_VY,-1;
	IF_BELOW	drift_y,0;
		ADD	PLAYER_VY,1;
	SET		drift_x,0;
	SET		drift_y,0;
	ADD		MY.DIST,-10;
	SET		MY.EACH_TICK,NULL;
	BRANCH	set_drive;
}

ACTION suck_health {
	SET		drift_x,MY.SKILL1;
	SET		drift_y,MY.SKILL2;
	CALL catch_drift;
	IF_ABOVE	fuel,0;	// noch warten?
		END;

	PLAY_SOUND klonk,0.2;
	ADD		MY.SKILL5,time_dec;
	RULE		val1 = TIME_CORR * 0.128;
	ADD		MY.OFFSET_Y,val1;
	IF_ABOVE	drown_count,0;	// haengt whopper dran?
		END;
	IF_BELOW	MY.SKILL5,0;	// leergesaugt?
		BRANCH	stop_refill;
	RULE		health = health + TIME_CORR;
	IF_MAX	health;
		BRANCH	stop_refill;
}

////////////////////////////////////////////////
// Object-Each_tick-Aktion fur dotz-Pause
ACTION dotz {
	IF_ABOVE	IMPACT_VX,0;
		SET	IMPACT_VX,2;
	IF_BELOW	IMPACT_VX,0;
		SET	IMPACT_VX,-2;
	IF_ABOVE	IMPACT_VY,0;
		SET	IMPACT_VY,2;
	IF_BELOW	IMPACT_VY,0;
		SET	IMPACT_VY,-2;
	SET		MY.DIST,0.1;	// IF_NEAR verhindern

	WAIT_TICKS	16;

	SET		MY.DIST,0;		// IF_NEAR wieder aktivieren
	SET		MY.EACH_TICK,NULL;
}
////////////////////////////////////////////////
ACTION light_up {
	ADD		PLAYER_LIGHT,0.1;
	IF_ABOVE	PLAYER_LIGHT,3;
		SET	PLAYER_LIGHT,3;
}

ACTION light_dn {
	ADD		PLAYER_LIGHT,-0.1;
	IF_BELOW	PLAYER_LIGHT,0;
		SET	PLAYER_LIGHT,0;
}
////////////////////////////////////////////////
ACTION skaph_qexit {
	SET	screen_msg.STRING,exit_1;
	IF_BELOW	RANDOM,0.5;
		SET	screen_msg.STRING,exit_2;
	IF_BELOW	RANDOM,0.45;
		SET	screen_msg.STRING,exit_3;
	IF_BELOW	RANDOM,0.40;
		SET	screen_msg.STRING,exit_4;
	IF_BELOW	RANDOM,0.35;
		SET	screen_msg.STRING,exit_5;
	IF_BELOW	RANDOM,0.30;
		SET	screen_msg.STRING,exit_6;
	IF_BELOW	RANDOM,0.25;
		SET	screen_msg.STRING,exit_7;
	IF_BELOW	RANDOM,0.20;
		SET	screen_msg.STRING,exit_8;
	IF_BELOW	RANDOM,0.15;
		SET	screen_msg.STRING,exit_9;
	IF_BELOW	RANDOM,0.10;
		SET	screen_msg.STRING,exit_0;
	SET	IF_Y,skaph_exit;
	SET	IF_Z,skaph_exit;
	SET	IF_J,skaph_exit;
	BRANCH		wait_yesno;
}

////////////////////////////////////////////////
SKILL	fade 		{ VAL 0; }

ACTION skaph_fadein {
/*
	SET		fade,0;
fadein_1:
	RULE		fade = fade + 0.07;
	FADE_PAL	pal1,fade;
	WAIT		1;
	IF_BELOW	fade,1;
		SKIP	-4;
*/
	SET		EACH_TICK.16,NULL;
	BRANCH	set_drive;
}

ACTION skaph_fadeout {
	SET		EACH_TICK.16,skaph_fadeout;
	SET		fade,0;

	RULE		fade = fade + 0.07;
	FADE_PAL	black_pal,fade;
	WAIT		1;
	IF_BELOW	fade,1;
		SKIP	-4;
	EXIT		finale_laber;
}

/////////////////////////////////////////////////////////////////
ACTION skaph_start {
#	CALL	skaph_gload;			// Letztes Ende-Info wieder laden
	SET	RENDER_MODE,1;
	SET	frame_color, 1;
	SET	PANELS.1,panel_a;
#	SET	PANELS.2,debug_panel;
	SET	LAYERS.16,cockpit;
	SET	MAP_LAYER,15;
	SET	last_gndz,PLAYER_Z;	// letztes Z bei boden unter den Fuessen
	SET	EACH_TICK.12,NULL;
	SET	EACH_TICK.15,skaph_panel;
	SET	EACH_TICK.16,skaph_fadein;
	SET	EACH_SEC.16,skaph_sec;

	SET	my_size,4;
	SET	PLAYER_SIZE,my_size;
	SET	PLAYER_SIZE.MAX,my_size;

	SET	difficulty,3;

	SET	IF_ESC,	skaph_qexit;

	SET	IF_F1,	help_skaph;
	SET	IF_F5,	switch_mblur;
	SET	IF_F10,	skaph_qexit;
	SET	IF_F12,	switch_music;

	SET	IF_SZ,	shrink;
	SET	IF_MINUS,shrink;
	SET	IF_APO,	inflate;
	SET	IF_PLUS,	inflate;

	SET	IF_0,		set_gun0;
	SET	IF_1,		set_gun1;
	SET	IF_2,		set_gun2;

	SET	IF_LEFT,	fire_start;
	SET	IF_CTRL,	fire_start;

	SET	IF_SPACE,manipulate;
	SET	IF_BKSP,	manipulate;
	SET	IF_RIGHT,manipulate;
	SET	IF_P,		switch_pause;

	SAVE	"SKSTA",0;		// Level-Start fuer Ruecksprung speichern

	WAIT	16;
// Anfangs-Initialisierung
	SET		MOTION_BLUR,0.5;
	IF_ABOVE	TIME_CORR,2;
		SET	MOTION_BLUR,1;
	IF_BELOW	TIME_CORR,1.2;
		SET	MOTION_BLUR,0;
}

// Alles setzen nach laden neuer global-skills
ACTION load_global {
	IF_EQUAL	gun_type,0;		// Bei Levelstart letzte Kanone setzen
		CALL	set_gun0;
	IF_EQUAL	gun_type,1;
		CALL	set_gun1;
	IF_EQUAL	gun_type,2;
		CALL	set_gun2;
	CALL		set_smus;
	BRANCH	set_scrsize;
}

ACTION skaph_exit {
#	CALL	skaph_gsave;			// letzten Skill-Stand sichern
	SET	EACH_TICK.12,NULL;
	SET	EACH_TICK.13,NULL;
	SET	EACH_TICK.14,NULL;
	SET	EACH_TICK.15,NULL;
	SET	EACH_TICK.16,skaph_fadeout;
}

/////////////////////////////////////////////////////////
BMAP	braino1_bmp,<brainout.lbm>,5,3,35,46;
BMAP	braino2_bmp,<brainout.lbm>,50,3,35,46;

PANEL brain1_pan { POS_X 237; POS_Y 63; PAN_MAP braino1_bmp; FLAGS REFRESH; }
PANEL brain2_pan { POS_X 237; POS_Y 63; PAN_MAP braino2_bmp; FLAGS REFRESH; }
PANEL panel_die {	POS_X	0;	POS_Y	0; PAN_MAP brainout; FLAGS REFRESH;}

ACTION clear_keys {	// Loesche alle Keys ausser F3 und F10
	SET	IF_F1,	NULL;
	SET	IF_F2,	NULL;
	SET	IF_F5,	NULL;
	SET	IF_F11,	NULL;
	SET	IF_F12,	NULL;

	SET	IF_0,		NULL;
	SET	IF_1,		NULL;
	SET	IF_2,		NULL;
	SET	IF_3,		NULL;
	SET	IF_4,		NULL;
	SET	IF_5,		NULL;
	SET	IF_6,		NULL;
	SET	IF_7,		NULL;

	SET	IF_LEFT,	NULL;
	SET	IF_CTRL,	NULL;
	SET	IF_SPACE,NULL;
	SET	IF_BKSP,	NULL;
	SET	IF_RIGHT,NULL;
	SET	IF_JOY4,	NULL;

	SET	IF_SZ,	NULL;
	SET	IF_MINUS,NULL;
	SET	IF_APO,	NULL;
	SET	IF_PLUS,	NULL;

	SET	IF_ESC,	NULL;
	SET	IF_P,		NULL;
	SET	IF_TAB,	NULL;
	SET	IF_ENTER,NULL;

	SET	fire,tu_nix;
}

ACTION clear_layers {
	SET	PANELS.1,NULL;			// cockpit
	SET	PANELS.2,NULL;			// debug
	SET	PANELS.3,NULL;			// EKG
	SET	PANELS.14,NULL;		// display
	SET	PANELS.15,NULL;		// mine

	SET	LAYERS.1,NULL;
	SET	LAYERS.2,NULL;
	SET	LAYERS.3,NULL;
	SET	LAYERS.4,NULL;
	SET	LAYERS.5,NULL;
	SET	LAYERS.6,NULL;
	SET	LAYERS.14,NULL;		// cockpit alt
	SET	LAYERS.15,NULL;		// whopper
	SET	LAYERS.16,NULL;		// cockpit

	SET	MESSAGES.16,NULL;

	SET	EACH_TICK.10,NULL;	// load_levelstart
	SET	EACH_TICK.11,NULL;	// whopper
	SET	EACH_TICK.12,NULL;
	SET	EACH_TICK.13,NULL;	// gun
	SET	EACH_TICK.14,NULL;	// message
	SET	EACH_TICK.15,NULL;	// skaph-panel

	SET	RENDER_MODE,0;
	SET	MOVE_MODE,0;			// Keine Animation mehr
	SET	MAP_MODE,0;
	SET	SOUND_VOL,0;
	SET	fire,tu_nix;
}

ACTION skaph_die {
	SET	energy,0;
#	SET	MOVE_MODE,0.5;			// freeze all objects
	SET	MESSAGES.16,NULL;
	SET	EACH_TICK.10,NULL;	// load_levelstart
	SET	EACH_TICK.11,NULL;	// whopper
	SET	EACH_TICK.12,NULL;
	SET	EACH_TICK.13,NULL;	// gun
	SET	EACH_TICK.14,NULL;	// message
	SET	EACH_TICK.15,NULL;	// skaph-panel
	SET	EACH_TICK.16,skaph_die;
	CALL	clear_keys;
	WAIT	1;

	PLAY_SOUND	zschbumm,0.4;

	SET	fade,0;
skdie_11:
	RULE	PLAYER_VZ = PLAYER_VZ + 0.01*TIME_CORR;
	RULE	PLAYER_VROT = PLAYER_VROT + 0.01*TIME_CORR;
	RULE	fade = fade + 0.02*TIME_CORR;
	FADE_PAL	red_pal,fade;
	WAIT	1;
	IF_BELOW	fade,0.9;
		GOTO	skdie_11;

	SET	health,300;				// Auf Defaultwerte setzen
	SET	energy,200;
	RULE	MUSIC_VOL = 0.5*MUSIC_VOL;

	CALL	clear_layers;
	SET	PANELS.1,panel_die;
	SET	EACH_TICK.15,blink_brain;
	SET	screen_msg.STRING,abkratz_1;
	IF_BELOW	RANDOM,0.5;
		SET	screen_msg.STRING,abkratz_2;
	IF_BELOW	RANDOM,0.45;
		SET	screen_msg.STRING,abkratz_3;
	IF_BELOW	RANDOM,0.40;
		SET	screen_msg.STRING,abkratz_4;
	IF_BELOW	RANDOM,0.35;
		SET	screen_msg.STRING,abkratz_5;
	IF_BELOW	RANDOM,0.30;
		SET	screen_msg.STRING,abkratz_6;
	IF_BELOW	RANDOM,0.25;
		SET	screen_msg.STRING,abkratz_7;
	IF_BELOW	RANDOM,0.20;
		SET	screen_msg.STRING,abkratz_8;
	IF_BELOW	RANDOM,0.15;
		SET	screen_msg.STRING,abkratz_9;
	IF_BELOW	RANDOM,0.10;
		SET	screen_msg.STRING,abkratz_0;

	SET	MESSAGES.16,screen_msg;
sdie_nomsg:

	SET	fade,0;
skaphdie_3:
	RULE	fade = fade + 0.1;
	FADE_PAL	picture_pal,fade;
	WAIT	1;
	IF_BELOW	fade,1;
		GOTO	skaphdie_3;
	SET	fade,0;

	SET		IF_ENTER,skaph_reload;
	SET		IF_ESC,skaph_reload;
	WAITT		100;
	BRANCH	skaph_reload;
}

ACTION skaph_reload {
	SET		EACH_TICK.15,NULL;
	SET		EACH_TICK.16,NULL;
	LOAD		"SKSTA",0;		// Level-Start wieder laden
}

ACTION blink_brain {
	SET		PANELS.2,brain1_pan;
	SET		blink_count,0;
	WAIT		1;
	ADD		blink_count,TIME_CORR;
	IF_BELOW	blink_count,16;
		SKIP	-3;

	SET		PANELS.2,brain2_pan;
	SET		blink_count,0;
	WAIT		1;
	ADD		blink_count,TIME_CORR;
	IF_BELOW	blink_count,16;
		SKIP	-3;
}

/////////////////////////////////////////////
// Tastenbelegung
ACTION manipulate {
	SET	gun_strength,0;
	SET	SHOOT_RANGE,14;	// Marker!!
	PUSH	14;
}
/*

	SET	SHOOT_Y,-0.95;			// unterer Rand
	SHOOT;
#	IF_ABOVE	HIT_DIST,0,mani_raus;
// Kein Mehrfachschuss, da in gleicher Aktion

	SET	SHOOT_Y,-0.5;
	SHOOT;
#	IF_ABOVE	HIT_DIST,0,mani_raus;

	SET	SHOOT_Y,0;
	SHOOT;								// loest if_hit bei objekten aus
#	IF_ABOVE	HIT_DIST,0,mani_raus;	// was getroffen?

	SET	SHOOT_Y,0.5;
	SHOOT;
#	IF_ABOVE	HIT_DIST,0,mani_raus;

	SET	SHOOT_Y,0;
	SET	SHOOT_X,-0.3;
	SHOOT;
#	IF_ABOVE	HIT_DIST,0,mani_raus;

	SET	SHOOT_X,0.3;
	SHOOT;
#	IF_ABOVE	HIT_DIST,0,mani_raus;

	SET	SHOOT_Y,-0.95;			// unterer Rand
	SET	SHOOT_X,-0.3;
	SHOOT;
#	IF_ABOVE	HIT_DIST,0,mani_raus;

	SET	SHOOT_X,0.3;
	SHOOT;

mani_raus:
	SET	SHOOT_Y,0;
	SET	SHOOT_X,0;
}
*/

ACTION cheat {
	SET		health,health.MAX;
	SET		energy,energy.MAX;
	SET		gun1,1;
	SET		gun2,1;
	SET		gun3,1;
	SET		gun4,1;
	SET      gun5,1;
	IF_BELOW	shield,1000;
	SET      shield,1000;
	IF_BELOW	minen,3;
		SET	minen,3;
}

ACTION switch_pause {
	PLAY_SOUND	button,0.2;
	ADD		pause,1;
	IF_ABOVE	pause,1;
		SET	pause,0;

	IF_EQUAL	pause,1;
		GOTO	set_pause;
	SET		MESSAGES.16,NULL;
	SET		MOVE_MODE,1;
	IF_EQUAL	service_mode,1;
		SET	MOVE_MODE,0.5;
	BRANCH	set_smus;

set_pause:
	SET		screen_msg.STRING,pause_on;
	SET		MESSAGES.16,screen_msg;
	SET		MOVE_MODE,-1;	// Auch each_ticks stoppen
	SET		MUSIC_VOL,0;
	SET		SOUND_VOL,0;
}

//////////////////////////////////////////
ACTION set_smus {
	SET		MUSIC_VOL,old_music;
	SET		SOUND_VOL,old_sound;
	IF_ABOVE	smus,0;
		SET	MUSIC_VOL,0;
	IF_ABOVE	smus,1;
		SET	SOUND_VOL,0;
}

ACTION shrink {
	IF_EQUAL	MAP_MODE,0;
		BRANCH	shrink_screen;
}
ACTION inflate {
	IF_EQUAL	MAP_MODE,0;
		BRANCH	inflate_screen;
}

ACTION set_scrsize {
	IF_BELOW	screen_size,1;
		GOTO	sscr_1;
	SET		screen_size,1;
	SET		SCREEN_X,24;	// default values
	SET		SCREEN_Y,14;
	SET		SCREEN_WIDTH,272;
	SET		SCREEN_HGT,318;
	END;
sscr_1:
	IF_BELOW	screen_size,0.5;
		SET	screen_size,0.5;
	IF_ABOVE	screen_size,0.49;
		SET	SCREEN_WIDTH,144;
	IF_ABOVE	screen_size,0.56;
		SET	SCREEN_WIDTH,160;
	IF_ABOVE	screen_size,0.62;
		SET	SCREEN_WIDTH,176;
	IF_ABOVE	screen_size,0.68;
		SET	SCREEN_WIDTH,192;
	IF_ABOVE	screen_size,0.74;
		SET	SCREEN_WIDTH,208;
	IF_ABOVE	screen_size,0.81;
		SET	SCREEN_WIDTH,224;
	IF_ABOVE	screen_size,0.87;
		SET	SCREEN_WIDTH,240;
	IF_ABOVE	screen_size,0.93;
		SET	SCREEN_WIDTH,256;
	RULE		SCREEN_HGT	= 1.162*SCREEN_WIDTH;
	RULE		SCREEN_X 	= -0.5*SCREEN_WIDTH + 160;
	RULE		SCREEN_Y 	= -0.5*SCREEN_HGT + 172;
}

ACTION shrink_screen {
	PLAY_SOUND	button,0.2;
	ADD 		screen_size,-0.063;	//=272/16
	BRANCH	set_scrsize;
}

ACTION inflate_screen {
	PLAY_SOUND	button,0.2;
	ADD 		screen_size,0.063;
	BRANCH	set_scrsize;
}
//////////////////////////////////////////////////
ACTION inc_volume {
	PLAY_SOUND	button,0.2;
	RULE		old_music = 1.1*old_music + 0.1;
	RULE		old_sound = 1.1*old_sound + 0.1;
	BRANCH	set_smus;
}

ACTION dec_volume {
	PLAY_SOUND	button,0.2;
	RULE		old_music = 0.9*old_music + -0.1;
	RULE		old_sound = 0.9*old_sound + -0.1;
	BRANCH	set_smus;
}


ACTION switch_mblur {
	PLAY_SOUND	button,0.2;
	IF_BELOW	MOTION_BLUR,1;
		GOTO	smblur_1;
	SET	MOTION_BLUR,0;
	SET	screen_msg.STRING,mblur_0;
	SET	EACH_TICK.14,show_message;
	END;
smblur_1:
	IF_BELOW	MOTION_BLUR,0.5;
		GOTO	smblur_2;
	SET		MOTION_BLUR,1;
	SET		screen_msg.STRING,mblur_2;
	SET		EACH_TICK.14,show_message;
	END;
smblur_2:
	SET		MOTION_BLUR,0.5;
	SET		screen_msg.STRING,mblur_1;
	SET		EACH_TICK.14,show_message;
	END;
}
ACTION switch_music {
	PLAY_SOUND	button,0.2;
	ADD		smus,1;
	IF_ABOVE	smus,1,smus_1;
		SET	SOUND_VOL,old_sound;
		SET	MUSIC_VOL,0;
		SET	screen_msg.STRING,music_1;
		SET	EACH_TICK.14,show_message;
	END;
smus_1:
	IF_ABOVE	smus,2,smus_2;
		SET	SOUND_VOL,0;
		SET	MUSIC_VOL,0;
		SET	screen_msg.STRING,music_0;
		SET	EACH_TICK.14,show_message;
	END;
smus_2:
		SET	smus,0;
		SET	MUSIC_VOL,old_music;
		SET	SOUND_VOL,old_sound;
		SET	screen_msg.STRING,music_2;
		SET	EACH_TICK.14,show_message;
	END;
}
/////////////////////////////////////////////////
ACTION help_skaph {
	PLAY_SOUND	button,0.2;
	SET		screen_msg.STRING,briefing;
	SET		IF_F1,help_skaph2;
	BRANCH			show_help;
}

ACTION help_skaph2 {
	PLAY_SOUND	button,0.2;
	SET		screen_msg.STRING,motion_s;
	SET		IF_F1,help_skaph3;
	BRANCH			show_help;
}

ACTION help_skaph3 {
	PLAY_SOUND	button,0.2;
	SET		screen_msg.STRING,tasten_s;
	SET		IF_F1,help_skaph4;
	BRANCH			show_help;
}
ACTION help_skaph4 {
	PLAY_SOUND	button,0.2;
	SET		screen_msg.STRING,function_s;
	SET		IF_F1,help_weg;
	BRANCH			show_help;
}

ACTION help_weg {
	PLAY_SOUND	button,0.2;
	SET		IF_F1,help_skaph;
	BRANCH			clear_message;
}

ACTION show_help {
	SET		message_delay,200;
	BRANCH			show_message;
}
/////////////////////////////////////////////
ACTION switch_floor {
	ADD	FLOOR_MODE,1;
	IF_ABOVE	FLOOR_MODE,1;
		SET	FLOOR_MODE,0;
}

//////////////////////////////////////////////
// Cheats:
// SKAFUL (AMMO + alles full),
//	SKAJET (= rocket),

IF_S	cheat_s;
IF_K	cheat_k;
IF_A	cheat_a;

IF_F	cheat_f;
IF_U	cheat_u;
IF_L	cheat_l;

IF_J	cheat_j;
IF_E	cheat_e;
IF_T	cheat_t;

ACTION cheat_s {
	SET		skatomic,1;
	SET		skajet,1;
	SET		skanex,1;
	SET		skaful,1;
}
ACTION cheat_k {
	ADD		skatomic,1;
	IF_NEQUAL	skatomic,2;
		SET	skatomic,0;

	ADD		skajet,1;
	IF_NEQUAL	skajet,2;
		SET	skajet,0;

	ADD		skanex,1;
	IF_NEQUAL	skanex,2;
		SET	skanex,0;

	ADD		skaful,1;
	IF_NEQUAL	skaful,2;
		SET	skaful,0;
}
ACTION cheat_a {
	ADD		skatomic,1;
	IF_NEQUAL	skatomic,3;
		SET	skatomic,0;

	ADD		skajet,1;
	IF_NEQUAL	skajet,3;
		SET	skajet,0;

	ADD		skanex,1;
	IF_NEQUAL	skanex,3;
		SET	skanex,0;

	ADD		skaful,1;
	IF_NEQUAL	skaful,3;
		SET	skaful,0;
}
ACTION cheat_f {
	SET		skanex,0;
	SET		skatomic,0;
	SET		skajet,0;
	ADD		skaful,1;
	IF_NEQUAL	skaful,4;
		SET	skaful,0;
}
ACTION cheat_u {
	SET		skanex,0;
	SET		skatomic,0;
	SET		skajet,0;
	ADD		skaful,1;
	IF_NEQUAL	skaful,5;
		SET	skaful,0;
}
ACTION cheat_l {
	SET		skanex,0;
	SET		skatomic,0;
	SET		skajet,0;
	ADD		skaful,1;
	IF_NEQUAL	skaful,6;
		SET	skaful,0;
	IF_EQUAL	skaful,0;
		END;
	SET		skaful,0;
	PLAY_SOUND	button,0.2;
	SET		screen_msg.STRING,full_ammo;
	SET		EACH_TICK.14,show_message;
	BRANCH	cheat;
}
ACTION cheat_n {
	SET		skaful,0;
	SET		skatomic,0;
	SET		skajet,0;
	ADD		skanex,1;
	IF_NEQUAL	skanex,4;
		SET	skanex,0;
}
ACTION cheat_j {
	SET		skaful,0;
	SET		skatomic,0;
	SET		skanex,0;
	ADD		skajet,1;
	IF_NEQUAL	skajet,4;
		SET	skajet,0;
}
ACTION cheat_e {
	SET		skaful,0;
	SET		skatomic,0;
	ADD		skajet,1;
	IF_NEQUAL	skajet,5;
		SET	skajet,0;
	ADD		skanex,1;
	IF_NEQUAL	skanex,5;
		SET	skanex,0;
}
ACTION cheat_t {
	SET		skaful,0;
	SET		skanex,0;
	ADD		skatomic,1;
	IF_NEQUAL	skatomic,4;
		SET	skatomic,0;
	IF_NEQUAL	skajet,5;
		SET	skajet,0;
	IF_EQUAL	skajet,0;
		END;
	SET		skajet,0;
	BRANCH	do_skajet;
}
ACTION cheat_o {
	SET		skaful,0;
	SET		skanex,0;
	SET		skajet,0;
	ADD		skatomic,1;
	IF_NEQUAL	skatomic,5;
		SET	skatomic,0;
}
ACTION cheat_m {
	SET		skaful,0;
	SET		skanex,0;
	SET		skajet,0;
	ADD		skatomic,1;
	IF_NEQUAL	skatomic,6;
		SET	skatomic,0;
}
ACTION cheat_i {
	SET		skaful,0;
	SET		skanex,0;
	SET		skajet,0;
	ADD		skatomic,1;
	IF_NEQUAL	skatomic,7;
		SET	skatomic,0;
}
ACTION cheat_c {
	SET		skaful,0;
	SET		skanex,0;
	SET		skajet,0;
	IF_NEQUAL	skatomic,7;
		SET	skatomic,0;
	IF_EQUAL	skatomic,0;
		END;
	SET		skatomic,0;
	BRANCH	do_skatomic;
}

ACTION do_skatomic {
	SET		flash.HEIGHT,PLAYER_Z;
	SET		flash.DIST,0;
	SET		flash.INVISIBLE,0;
	SET		flash.TARGET,DROP;
	SET		flash.EACH_TICK,atomic;
}

ACTION atomic {
	SET		gun_strength,-4000;
	SET		SHOOT_FAC,1;
	SET		SHOOT_RANGE,1500;
	EXPLODE	MY;
	SET		flash.EACH_TICK,NULL;
	SET		flash.INVISIBLE,1;
}

ACTION do_skajet {
	PLAY_SOUND	button,0.2;
	SET		screen_msg.STRING,have_jet;
	SET		EACH_TICK.14,show_message;
	BRANCH	set_rocket;
}

//////////////////////////////////////////////////////////////////////////////////
